var Remote = function()
{
	var remote = {};
	var files;
	var debug = 0;
	
	remote.initPage = function()
	{
		Buttons.addClickHandler('close', App.closeWindow);
		//Buttons.addClickHandler('btnSaveToBase', remote.saveToBase);
		
		var url = '../OpenGrid.servlet?ID='+App.getSessionId();
		url += '&cmd=ListProjectFiles';
		url += '&clusterId='+Data.get('page-data', 'cluster-id', '');
		url += '&path='+encodeURIComponent(Data.get('page-data', 'path'));
		url += '&archive='+encodeURIComponent(Data.get('page-data', 'archive', ''));
		url += '&itemType='+Data.get('page-data', 'item-type', '');
		url += '&itemId='+Data.int('page-data', 'item-id');
		url += '&fileserver='+Data.int('page-data', 'fileserver-id', 0);
		
		Wizard.showLoadingAnimation('Loading files...');
		Wizard.asyncJsonRequest(url, remote.onFilesLoaded);
	}
	
	remote.onFilesLoaded = function(response)
	{
		files = response.files;
		if (files.length == 0)
		{
			Wizard.setFatalError('Could not find any files in folder ' + response.projectArchive + Data.get('page-data', 'path'));
			return;
		}

		var html = '<table id="file-list">';
		html += '<tr>';
		html += '<th></th>';
		html += '<th>Folder / file</th>';
		html += '<th class="file-size">Size</th>';
		html += '<th class="last-modified">Last modified</th>';
		html += '<th class="owner">Owner</th>';
		html += '<th>Download</th>';
		html += '</tr>';
		var currentFolder = '-';
		for (var fileNo = 0; fileNo < files.length; fileNo++)
		{
			var file = files[fileNo];
			var path = file.path;
			var i = path.lastIndexOf('/');
			
			var folder = (i > 0) ? path.substring(0, i) : '.';
			var filename = path.substring(i+1);
			file.folder = folder;
			file.name = filename;
			var lastDot = file.name.indexOf('.');
			file.ext = lastDot >= 0 ? file.name.substr(lastDot+1) : null;
			
			if (folder != currentFolder)
			{
				html += '<tr class="folder">';
				html += '<td><img src="../images/remote_folder.png"></td>';
				html += '<td colspan="5">'+Strings.encodeTags(folder)+'</td>';
				html += '</tr>';
				currentFolder = folder;
			}
			
			html += '<tr class="file highlight">';
			html += '<td></td>';
			html += '<td class="file-name">'+Strings.encodeTags(file.name)+'</td>';
			html += '<td class="file-size">'+Numbers.formatBytes(file.size)+'</td>';
			html += '<td class="last-modified">'+Reggie.reformatDate(file.lastModified)+'</td>';
			html += '<td class="owner">'+Strings.encodeTags(file.owner)+'</td>';
			html += '<td>';
			html += '<span class="link download-file" data-file-no="'+fileNo+'" title="Download this file to your local computer"><img src="../images/download.png"></span>';
			if (file.ext == 'txt' || file.ext == 'out' || file.ext == 'vcf' || file.ext == 'tsv' || file.ext == 'csv' || file.ext == 'bed')
			{
				html += '<span class="link view-tabular-file" data-file-no="'+fileNo+'" title="View this file as a data table"><img src="../images/report.png"></span>';
			}
			html += '</td>';
			html += '</tr>';
		}
		html += '</table>';
		Doc.element('files').innerHTML = html;

		var downloadable = document.getElementsByClassName('download-file');
		for (var fileNo = 0; fileNo < downloadable.length; fileNo++)
		{
			Events.addEventHandler(downloadable[fileNo], 'click', remote.downloadFile);
		}

		var tabular = document.getElementsByClassName('view-tabular-file');
		for (var fileNo = 0; fileNo < tabular.length; fileNo++)
		{
			Events.addEventHandler(tabular[fileNo], 'click', remote.viewTabularFile);
		}
	}
	
	remote.downloadFile = function(event)
	{
		var fileNo = Data.get(event.currentTarget, 'file-no');
		var file = files[fileNo];
		var path = Data.get('page-data', 'path')+'/'+file.path;

		var url = '../OpenGrid.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadProjectFile';
		url += '&clusterId='+encodeURIComponent(Data.get('page-data', 'cluster-id', ''));
		url += '&path='+encodeURIComponent(path);
		url += '&fileserver='+Data.int('page-data', 'fileserver-id', 0);
		url += '&archive='+encodeURIComponent(file.archive || '');
		url += '&size='+file.size;
		
		location.href = url;
	}
	
	remote.viewTabularFile = function(event)
	{
		var fileNo = Data.get(event.currentTarget, 'file-no');
		var file = files[fileNo];
		var path = Data.get('page-data', 'path')+'/'+file.path;

		var url = '../OpenGrid.servlet?ID='+App.getSessionId();
		url += '&cmd=ViewTabularFile';
		url += '&clusterId='+encodeURIComponent(Data.get('page-data', 'cluster-id', ''));
		url += '&path='+encodeURIComponent(path);
		url += '&fileserver='+Data.int('page-data', 'fileserver-id', 0);
		url += '&archive='+encodeURIComponent(file.archive || '');
		url += '&size='+file.size;
		
		Dialogs.openPopup(url, 'ViewTabularFile'+fileNo, 1200, 800);
	}

	return remote;
}();

Doc.onLoad(Remote.initPage);
