<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="java.util.regex.Pattern"
	import="java.util.regex.Matcher"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default">
<base:head 
	scripts="~../reggie-2.js,~import-transport-boxes.js" 
	styles="path.css,~../css/reggie-2.css"
	>
<style>
tr.highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}

#fileSummary
{
	margin: 0.5em;
	border-width: 1px;
}
#fileSummary b:first-child
{
	width: 15em;
}

#fileSummary b
{
	display: inline-block;
	background: #F0F0F0;
	padding: 0.3em 0.6em;
	margin-right: 0.25em;
}
#fileSummary span
{
	margin-right: 1em;
}

#fileSummary input[type="checkbox"]
{
	margin-left: -0.75em;
	margin-right: 1em;
}

#fileSummary div + div
{
	border-top-width: 1px;
	border-top-style: dotted;
}
#importPossible
{
	font-weight: bold;
}
#importPossible img
{
	margin-right: 0.25em;
}

#specimenTable
{
	width: 100%; 
	border-collapse: collapse;
	border-top-width: 1px;
}

#specimenTable thead
{
	border-bottom-width: 1px;
}

#specimenTable td, #specimenTable th
{
	padding: 1px 0.5em 1px 0.5em;
	text-align: left;
}

#specimenTable .header1 th
{
	text-align: center;
	font-style: italic;
	padding: 0.25em;
}

#specimenTable .shaded
{
	background-color: #F0F0F0;
}

#specimenTable .lineNo
{
	width: 5em;
	text-align: right;
	font-weight: bold;
}


#specimenTable td.icon
{
	width: 20px;
	min-width: 20px;
}

#specimenTable .comment input
{
	width: 95%;
	min-width: 20em;
}

#specimenTable .storage-box
{
	text-align: center;
}

#specimenTable .new-box
{
	border-top-width: 2px;
	border-top-style: solid;
}

#specimenTable .action
{
	margin-bottom: 0.25em;
}

img.case-summary
{
	margin-left: 0.25em;
}

img.line-info
{
	float: right;
}

#fileData.hide-specimen tr.Specimen,
#fileData.hide-nospecimen tr.NoSpecimen,
#fileData.hide-case tr.Case,
#fileData.hide-blood tr.Blood,
#fileData.hide-nothing tr.Nothing
{
	display: none;
}

#fileData.only-noconsent tr.HasConsent,
#fileData.only-errors tr.NoError,
#fileData.only-warnings tr.NoWarning
{
	display: none;
}

#fileData.only-noconsent tr.NoConsent,
#fileData.only-errors tr.HasError,
#fileData.only-warnings tr.HasWarning
{
	display: table-row;
}


</style>
</base:head>
<base:body>
	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Import specimen from transport boxes" 
		/></p:path>
	
	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">File</div>
		<div class="step-content">

			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">Select file</td>
				<td class="input">
					<table style="width: 100%;">
					<tr>
					<td>
						<input class="text required" type="text" name="importfile" id="importfile" 
							data-name-filter="%.csv|%.xlsx"
							data-directory="/home/SCANB/BiomaterialPathology"
						>
					</td>
					<td style="padding-left: 4px; width: 7em;">
						<base:button 
							title="Browse&hellip;"
							id="importfile.btn"
						/>
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="importfile.status"></td>
				<td class="help" rowspan="2">
					<span id="importfile.message" class="message"></span>
					Select the <b>CSV</b> or <b>Excel</b> file that contains information about specimen.
					The following columns are required: <b>Clarity ID</b>, <b>SCAN-B nummer</b> and
					<b>Förvaring</b>. 
					Optional columns are: <b>PADRemiss</b>. All other columns are ignored.
					<div id="worksheetSection.help" style="display:none;">
						Note that it is only possible to import from one worksheet at a time.
					</div>
				</td>
			</tr>
			<tr id="worksheetSection" style="display: none;">
				<td class="subprompt">- worksheet</td>
				<td class="input">
					<select name="sheet" id="sheet" class="required" style="width: auto; min-width: 10em;"></select>
				</td>
				<td class="status" id="sheet.status"></td>
			</tr>
			</table>
			
			<div id="filePreview" class="topborder" style="display: none;">
				<div id="fileSummary">
					<div>
						<b>Summary of file</b><span id="filename"></span><span 
							id="downloadfile" class="link" title="Download the file"><img src="../images/download.png"></span>
						<b>Boxes</b><span id="numBoxes"></span>
						<b>Total items</b><span id="numSamples"></span>
						<b>Errors</b><span id="numErrors"></span><input type="checkbox" id="showErrors" data-toggle="only-errors" title="Only show entries that have an error">
						<b>Warnings</b><span id="numWarnings"></span><input type="checkbox" id="showWarnings" data-toggle="only-warnings" title="Only show entries that have a warnings">
						<b>Consent=No/NotAsked</b><span id="numNoConsent"></span><input type="checkbox" id="showNoConsent" data-toggle="only-noconsent" title="Only show entries that is missing consent">
					</div>
					<div>
						<b>&nbsp;</b>
						<span id="importPossible"></span>
						<b>Mapped to</b><i>Specimen</i>: <span id="numMappedToSpecimen"></span><input type="checkbox" id="showSpecimen" checked data-toggle="hide-specimen" title="Show/hide entries that was mapped to a Specimen">
						<i>NoSpecimen</i>: <span id="numMappedToNoSpecimen"></span><input type="checkbox" id="showNoSpecimen" checked data-toggle="hide-nospecimen" title="Show/hide entries that was mapped to a NoSpecimen">
						<i>Case</i>: <span id="numMappedToCase"></span><input type="checkbox" id="showCase" checked data-toggle="hide-case" title="Show/hide entries that was mapped to a Case">
						<i>Blood</i>: <span id="numMappedToBlood"></span><input type="checkbox" id="showBlood" checked data-toggle="hide-blood" title="Show/hide entries that was mapped to a Blood">
						<i>Nothing</i>: <span id="numMappedToNothing"></span><input type="checkbox" id="showNothing" checked data-toggle="hide-nothing" title="Show/hide entries that was not mapped to anything">
					</div>
					<div id="boxComments" style="display: none;"></div>
				</div>
				<div id="fileData"></div>
			</div>

		</div>
	</div>

	<div id="wizard-status"></div>
	<div id="wizard-progress"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	</div>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>