<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	int fileId = Values.getInt(request.getParameter("fileId"));
	File file = File.getById(dc, fileId);
	String lastPassword = sc.getUserClientSetting("reggie.zip-password");
	if (file.isAnnotated())
	{
		ItemQuery<AnnotationType> query = AnnotationType.getQuery(Item.FILE);
		query.restrict(Restrictions.eq(Hql.property("name"), Expressions.string("ZipPassword")));
		query.setIncludes(Include.ALL);
		List<AnnotationType> result = query.list(dc);
		if (result.size() == 1)
		{
			AnnotationType zipPwd = result.get(0);
			AnnotationSet as = file.getAnnotationSet();
			if (as.hasAnnotation(zipPwd, Annotation.Source.PRIMARY))
			{
				lastPassword = (String)as.getAnnotation(zipPwd).getValues().get(0);
			}
		}
	}
%>
<base:page type="popup" title="Download as ZIP" id="password-dialog">
<base:head 
	scripts="~download-as-zip.js,~reggie-2.js"
	styles="~css/reggie-2.css"
/>
<base:body>
	<h1>Download as ZIP</h1>

	<div id="page-data" class="datacontainer"
		data-file-id="<%=fileId%>"
	></div>

	<form name="options" id="wizard" class="wizard">
	<div class="content bottomborder">
	
		<table class="fullform input100">
		<tr>
			<th>File</th>
			<td>
				<%=HTML.encodeTags(file.getName())%>
			</td>
		</tr>
		<tr>
			<th>Password</th>
			<td>
				<input class="text auto-init" data-auto-init="focus" style="width: calc(100% - 9em);"
					type="text" name="password" id="password" maxlength="20" value="<%=HTML.encodeTags(lastPassword)%>">
					<base:button id="generate" title="Generate" style="width: 6em;" />
			</td>
		</tr>
		<tr>
			<th class="subprompt"></th>
			<td style="padding: 0.5em; font-style: italic;">
				<ul style="padding-left: 1em;">
				<li>Max 20 characters.
				<li>If empty, the ZIP file is not password protected.
				</ul>
			</td>
		</tr>
		<tr>
			<th></th>
			<td>
				<label><input type="checkbox" name="rememberPassword" id="rememberPassword"
					<%=lastPassword != null ? "checked" : "" %>
				>Remember password</label> - 
				<i>the password is saved to the <code>ZipPassword</code> annotation on the file item.</i>
			</td>
		</tr>
		<tr class="dynamic">
			<th class="subprompt"></th>
			<td>
			</td>
		</tr>
		</table>
	
	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons" id="dialogbuttons">
		<base:button id="btnDownload" title="Download" image="<%=home+"/images/download-as-zip.png"%>" />
		<base:button id="close" title="Cancel" />
	</base:buttongroup>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>