<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" title="Flagged RNA wizard">
<base:head 
	scripts="~../reggie-2.js,~search.js" 
	styles="path.css,toolbar.css,~../css/reggie-2.css"
	>
<style>
#rnaTable
{
	width: 100%; 
	border-collapse: separate;
	border-bottom-width: 1px;
}

#rnaTable thead
{
	position: sticky;
	top: 1.8em;
}

#rnaTable thead tr:first-child th
{
	border-top-width: 1px;
}

#rnaTable thead tr:last-child th
{
	border-bottom-width: 1px;
}


#rnaTable .highlight td
{
	border-top-width: 1px;
	border-top-color: transparent;
	border-bottom-style: dotted;
	border-bottom-width: 1px;
}

#rnaTable .highlight.oddrow td
{
	border-bottom-color: transparent;
}

#rnaTable td
{
	text-align: center;
	width: 4.5em;
}

#rnaTable tbody td
{
	padding-top: 1px;
	padding-bottom: 1px;
}

#rnaTable tr td:first-child, #rnaTable tr th:first-child
{
	width: 7em;
	text-align: right;
	padding-right: 0.5em;
	white-space: nowrap;
	font-weight: bold;
}

#rnaTable input[type="text"], #rnaTable select
{
	width: calc(100% - 10px);
}

#rnaTable .case-summary
{
	margin-left: 4px;
}

#rnaTable td.iconcol-1
{
	width: 20px;
	text-align: left;
}

.if-yellow
{
	white-space: nowrap;
}

.donotuse
{
	color: #E80000;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Flagged RNA wizard" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step auto-hide absolutefull" id="step-1" style="position: absolute; margin-bottom: 0;">
		<div class="step-no">1</div>
		<div class="step-title absolutefull" style="height: 1.8em;">Select flagged RNA items (found <span id="num-matching">?</span>)</div>
		<div class="step-content absolutefull" style="top: 1.8em; border-bottom-width: 0;">
	
			<tbl:toolbar subclass="bg-filled-100" style="position: sticky; top: 0; height: 1.8em;">
				<tbl:button 
					id="btnReExtractSpecimen"
					image="<%=home + "/images/partition.png"%>"
					title="Re-extract from specimen&hellip;"
				/>
				<tbl:button 
					id="btnReExtractLysate"
					image="<%=home + "/images/extraction.png"%>"
					title="Re-extract from lysate&hellip;"
				/>
				<tbl:button 
					id="btnFlagSpecimen"
					image="<%=home + "/images/flag.png"%>"
					title="Flag specimen&hellip;"
				/>
				<tbl:button 
					id="btnReProcessRna"
					image="<%=home + "/images/pipette.png"%>"
					title="Re-process to libraries&hellip;"
				/>
				<tbl:button 
					id="btnUnflagRna"
					image="<%=home + "/images/unflag.png"%>"
					title="Unflag RNA&hellip;"
				/>
				<tbl:button 
					id="btnNewBioMaterialList"
					image="<%=home + "/images/new.png"%>"
					title="Create biomaterial list&hellip;"
				/>
				<tbl:button
					image="help.png"
					subclass="auto-init"
					data-auto-init="help"
					data-help-id="net.sf.basedb.reggie.flaggedrna"
					title="Help&hellip;"
					tooltip="Get help about this page"
				/>
			</tbl:toolbar>

			<table id="rnaTable">
			<thead class="bg-filled-100">
				<tr>
					<th colspan="2"></th>
					<th class="dottedleft" colspan="6">RNA</th>
					<th class="dottedleft" colspan="2">Lysate</th>
					<th class="dottedleft" colspan="2">Specimen</th>
					<th class="dottedleft">Library</th>
					<th class="dottedleft">Raw data</th>
				</tr>
		
				<tr>
					<th colspan="2"></th>
					<th class="dottedleft">Name</th>
					<th>Label</th>
					<th class="flag">Flag</th>
					<th>Original</th>
					<th>Remain</th>
					<th>RQS/RIN</th>
					<th class="dottedleft">Remain</th>
					<th>Used quantity</th>
					<th class="dottedleft">Remain</th>
					<th>Registered</th>
					<th class="dottedleft">Exists</th>
					<th class="dottedleft">Exists</th>
				</tr>
				
				<tr>
					<td colspan="2"></td>
					<td class="dottedleft"></td>
					<td></td>
					<td></td>
					<td>(µg)</td>
					<td>(µg)</td>
					<td></td>
					<td class="dottedleft">(µg)</td>
					<td>(mg)</td>
					<td class="dottedleft">(mg)</td>
					<td></td>
					<td class="dottedleft"></td>
					<td class="dottedleft" style="font-size:75%; white-space:nowrap;" 
						title="StringTie / Cufflinks / VariantCall">S.Tie/Cuff./V.Call</td>
				</tr>
		
				<tr>
					<th><base:icon image="check_uncheck.png" id="check_uncheck" style="margin-right: 22px;" /></th>
					<th></th>
					<th class="dottedleft"></th>
					<th>
						<select name="labelFilter" id="labelFilter">
							<option>
							<option value="1">yes
							<option value="0">no
						</select>
					</th>
					<th><select name="flagFilter" id="flagFilter"><option></select></th>
					<th><input type="text" name="rnaOriginalFilter" id="rnaOriginalFilter"></th>
					<th><input type="text" name="rnaRemainFilter" id="rnaRemainFilter"></th>
					<th><input type="text" name="rqsRinFilter" id="rqsRinFilter"></th>
					<th class="dottedleft"><input type="text" name="lysateRemainFilter" id="lysateRemainFilter"></th>
					<th><input type="text" name="lysateUsedQuantityFilter" id="lysateUsedQuantityFilter"></th>
					<th class="dottedleft"><input type="text" name="specimenRemainFilter" id="specimenRemainFilter"></th>
					<th></th>
					<th class="dottedleft">
						<select name="libExistsFilter" id="libExistsFilter">
							<option>
							<option value="&gt;1">yes
							<option value="0">no
						</select>
					</th>
					<th class="dottedleft">
						<select name="rawDataExistsFilter" id="rawDataExistsFilter">
							<option>
							<option value="&gt;1">yes
							<option value="0">no
						</select>
					</th>
				</tr>
			</thead>
			<tbody id="rna-list">
			</tbody>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>