var Xport = function()
{
	var xport = {};
	var previewTitle;
	var previewList;
	
	xport.initPage = function()
	{
		previewTitle = Doc.element('previewTitle');
		previewList = Doc.element('previewList');
		
		Buttons.addClickHandler('goexport', xport.goExport);
		Buttons.addClickHandler('gopreview', xport.goPreview);

		Doc.show('step-1');
		Doc.show('gopreview');
		Doc.show('goexport');
	}
	
	xport.goPreview = function()
	{
		xport.doExport(true);
	}
	
	xport.goExport = function()
	{
		xport.doExport(false);
	}
	
	xport.doExport = function(preview)
	{
		var url = '../Export.servlet?ID='+App.getSessionId();
		url += '&cmd=ExportMissingConsentDataSampleList';
		url += '&progressbar=export-missing-consent-progress';
		
		Wizard.showLoadingAnimation('Working...', 'export-missing-consent-progress');
		Doc.hide('navigation');
		Doc.hide('previewWrapper');

		if (preview) 
		{
			url += '&preview=1';
			Wizard.asyncJsonRequest(url, xport.onPreviewLoaded);
		}
		else
		{
			window.location = url;		
		}
	}

	xport.onPreviewLoaded = function(response)
	{
		Doc.show('navigation');

		var allLines = response.split('\n');
		var numCases = allLines.length - 2; // First line is a header line
		
		var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
		// Check last column for the 'Consent' value
		var numConsentWithoutDate = 0;
		var numMissingConsent = 0;
		var numYesConsent = 0;
		var numNoConsent = 0;
		var numNotAskedConsent = 0;
		for (var i = 1 ; i <= numCases; i++)
		{
			var line = allLines[i];
			var cols = line.split(/\t/);
			var consent = cols[cols.length-1];
			var rowClass = '';
			if (consent == null || consent == 'null')
			{
				rowClass = 'consent-warning';
				numMissingConsent++;
			}
			else if (consent == 'Yes')
			{
				numYesConsent++;
			}
			else if (consent == 'No')
			{
				numNoConsent++;
			}
			else if (consent == 'Not asked')
			{
				numNotAskedConsent++;
			}
			html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
		}
		numConsentWithoutDate = numCases - numMissingConsent;

		previewTitle.innerHTML = numCases + ' Samples = ' + numConsentWithoutDate + ' unknown date (' + numYesConsent + ' Yes, ' + numNoConsent + ' No, ' + numNotAskedConsent + ' Not asked) + ' + numMissingConsent + ' missing consent';
		previewList.innerHTML = '<table>'+html+'</table>';
		Doc.show('previewWrapper');
	}

	return xport;
}();

Doc.onLoad(Xport.initPage);

