var Iport = function()
{
	var iport = {};
	var debug = 0;
	
	var importFileIsValid = false;
	var checkType;

	iport.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', iport.validateStep1);
		Events.addEventHandler('exportDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('importfile', 'change', iport.importFileOnChange);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', iport.initializeStep2);
		
		// Navigation
		Buttons.addClickHandler('fullcheck', iport.startCheck);
		Buttons.addClickHandler('simplecheck', iport.startCheck);
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('goimport', Wizard.goRegister);
		Buttons.addClickHandler('downloadreportfile', iport.downloadReportFile);
		Buttons.addClickHandler('downloadoutputfile', iport.downloadReportFile);

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', iport.submit);
		
		Doc.show('step-1');
		Doc.show('fullcheck');
		Doc.show('simplecheck');

		Doc.element('exportDate').focus();
		Wizard.setInputStatus('importfile', 'invalid', 'Please select a file!');
		iport.importFileOnChange();
	}
	
	iport.startCheck = function(event)
	{
		checkType = event.currentTarget.id;
		Doc.hide('downloadreportfile');
		Wizard.setCurrentStep(1);
		Doc.addClass('step-2', 'disabled');
		Wizard.goNext();
	}
	
	iport.validateStep1 = function(event)
	{
		var valid = importFileIsValid;
		valid &= Wizard.isValid('exportDate');
		if (!valid) event.preventDefault();
	}

	iport.importFileOnChange = function()
	{
		importFileIsValid = false;
		Wizard.setInputStatus('importfile');
		
		var frm = document.forms['reggie'];
		var files = frm.importfile.files;

		if (files.length == 1)
		{
			importFileIsValid = true;
			Wizard.setInputStatus('importfile', 'valid');
		}
		else
		{
			Wizard.setInputStatus('importfile', 'invalid', 'A file must be selected.');
		}
	}


	iport.initializeStep2 = function()
	{
		Doc.hide('explainFileCheck');
		var frm = document.forms['reggie'];
		var exportDate = frm.exportDate.value;

		var formData = new FormData();
		var files = frm.importfile.files;
		for (var i = 0; i < files.length; i++)
		{
			var file = files[i];
			formData.append('incafiles[]', file, file.name);
		}

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportInca';
		url += '&exportdate='+encodeURIComponent(exportDate);
		url += '&checkType=' + checkType;

		// POST
		Wizard.showLoadingAnimation('Checking INCA data...', 'inca-import-progress');
		Wizard.asyncJsonRequest(url, iport.checkCompleted, 'POST', formData);
	}
	
	iport.checkCompleted = function(response)
	{
		var fileInfo = response.fileInfo;
		var headers = fileInfo.headers;
		
		var checkType = response.checkType;
		var fileCanBeImported = true;
		
		Doc.element('filename').innerHTML = Strings.encodeTags(fileInfo.filename);
		Doc.element('isFollowUp').innerHTML = fileInfo.isFollowUp ? 'Yes' : 'No';
		Doc.element('headerCount').innerHTML = headers.count;
		
		Doc.element('headerMissing').innerHTML = headers.missing;
		if (headers.missing > 0)
		{
			fileCanBeImported = false;
			Wizard.setInputStatus('headerMissing', 'invalid', 'One ore more required headers are missing: <b>' + Strings.encodeTags(headers.missingNames.join(', ')) + '</b>');
		}
		else
		{
			Wizard.setInputStatus('headerMissing', 'valid');
		}
		
		Doc.element('headerDuplicates').innerHTML = headers.duplicates;
		if (headers.duplicates > 0)
		{
			fileCanBeImported = false;
			Wizard.setInputStatus('headerDuplicates', 'invalid', 'Duplicate headers must be removed before the file can be imported: <b>' + Strings.encodeTags(headers.duplicateNames.join(', ')) + '</b>');
		}
		else
		{
			Wizard.setInputStatus('headerDuplicates', 'valid');
		}
		
		Doc.element('headerUnknown').innerHTML = headers.unknown;
		if (headers.unknown > 0)
		{
			Wizard.setInputStatus('headerUnknown', 'warning', 'Data in columns that can\'t be mapped to INCA annotations is ignored.');
		}
		
		Doc.element('headerMapped').innerHTML = headers.mapped;
		if (headers.mapped == 0)
		{
			fileCanBeImported = false;
			Wizard.setInputStatus('headerMapped', 'invalid', 'No columns could be mapped to INCA annotations.');
		}
		else
		{
			Wizard.setInputStatus('headerMapped', 'valid', 'Existing INCA annotations that are found in the file.');
		}
		
		Doc.element('headerUnmapped').innerHTML = headers.unmapped;
		if (headers.unmapped > 0)
		{
			Wizard.setInputStatus('headerUnmapped', 'warning', 'Existing INCA annotations that are not found in the file.');
		}
		
		var importLineCount = fileInfo.data.count - fileInfo.data.totalExcluded;
		Doc.element('lineCount').innerHTML = fileInfo.data.count;
		Doc.element('importLineCount').innerHTML = importLineCount + (checkType == 'simplecheck' ? ' *' : '');
		Doc.element('totalExcluded').innerHTML = fileInfo.data.totalExcluded;
		if (fileInfo.data.count == 0)
		{
			fileCanBeImported = false;
			Wizard.setInputStatus('lineCount', 'invalid', 'The file contains no data.');
		}
		else if (importLineCount == 0)
		{
			fileCanBeImported = false;
			Wizard.setInputStatus('importLineCount', 'invalid', 'The file contains no data that can be imported.');
		}
		else 
		{
			if (checkType == 'simplecheck')
			{
				Wizard.setInputStatus('importLineCount', '', '* May change after the \'Full file check\'.');
			}
			else
			{
				Wizard.setInputStatus('importLineCount', 'valid');
				Wizard.showGoNextConfirmation(false, importLineCount + ' of ' + fileInfo.data.count + ' data lines can be imported.');
			}
		}
		
		if (iport.setExcludedLines('tooManyColumns', fileInfo.data.TOO_MANY_COLUMNS) > 0)
		{
			fileCanBeImported = false;
			Wizard.setInputStatus('tooManyColumns', 'invalid', 'All data lines must have the same number of columns.');
		}
		
		if (iport.setExcludedLines('tooFewColumns', fileInfo.data.TOO_FEW_COLUMNS) > 0)
		{
			fileCanBeImported = false;
			Wizard.setInputStatus('tooFewColumns', 'invalid', 'All data lines must have the same number of columns.');
		}
		
		if (iport.setExcludedLines('missingPersonalNo', fileInfo.data.MISSING_PERSONAL_NO) > 0)
		{
			Wizard.setInputStatus('missingPersonalNo', 'warning', 'Lines without personal number are skipped.');
		}
		
		if (iport.setExcludedLines('missingLaterality', fileInfo.data.MISSING_LATERALITY) > 0)
		{
			Wizard.setInputStatus('missingLaterality', 'warning', 'Lines without laterality are skipped.');
		}
		
		if (iport.setExcludedLines('duplicateLaterality', fileInfo.data.DUPLICATE_LATERALITY) > 0)
		{
			Wizard.setInputStatus('duplicateLaterality', 'warning', 'Lines with same personal number and laterality are skipped.');
		}
		
		if (iport.setExcludedLines('missingFollowUpDate', fileInfo.data.MISSING_FOLLOWUP_DATE) > 0)
		{
			Wizard.setInputStatus('missingFollowUpDate', 'warning', 'Follow-up entries without a date are skipped.');
		}
		
		if (iport.setExcludedLines('duplicateFollowUp', fileInfo.data.DUPLICATE_FOLLOWUP) > 0)
		{
			Wizard.setInputStatus('duplicateFollowUp', 'warning', 'Only the latest follow-up entry for the same personal number and laterality is imported.');
		}
		
		if (iport.setExcludedLines('invalidDataValue', fileInfo.data.INVALID_DATA_VALUE) > 0)
		{
			Wizard.setInputStatus('invalidDataValue', 'warning', 'Lines with invalid values are skipped.');
		}
		
		if (iport.setExcludedLines('patientNotFound', checkType == 'simplecheck' ? '<i>not checked</i>' : fileInfo.data.PATIENT_NOTIN_DATABASE) > 0)
		{
			Wizard.setInputStatus('patientNotFound', 'warning', 'Lines with a personal number not found in the database are skipped.');
		}
		
		if (iport.setExcludedLines('caseNotFound', checkType == 'simplecheck' ? '<i>not checked</i>' : fileInfo.data.CASE_NOTIN_DATABASE) > 0)
		{
			Wizard.setInputStatus('caseNotFound', 'warning', 'Lines with a personal number and laterality not found in the database are skipped.');
		}
		
		Wizard.setCurrentStep(2);
		if (fileCanBeImported)
		{
			if (checkType == 'fullcheck')
			{
				Doc.show('goimport');
				Doc.show('downloadoutputfile');
			}
			else
			{
				Doc.show('fullcheck');
			}
			Doc.show('gocancel');
		}
		else
		{
			Wizard.setWizardStatus('messagecontainer error', 'Import is not possible.');
			Wizard.setNoConfirm(true);
			Doc.show('gorestart');
		}
		
		Doc.show('downloadreportfile');
	}

	/**
		Set the value for an 'excluded line' variable. If the
		number of excluded lines is 0 the entire row is hidden.
	*/
	iport.setExcludedLines = function(elementId, numLines)
	{
		Doc.element(elementId).innerHTML = numLines;
		Doc.showHide(elementId+'.row', numLines > 0);
		return numLines;
	}

	iport.downloadReportFile = function(event)
	{
		var reportType = Data.get(event.currentTarget, 'report-type');

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadIncaReportFile';
		url += '&reporttype='+encodeURIComponent(reportType);
		window.open(url);
	}

	iport.submit = function()
	{
		Doc.hide('downloadreportfile');
		Doc.hide('downloadoutputfile');
		
		var frm = document.forms['reggie'];
		var exportDate = frm.exportDate.value;

		var formData = new FormData();
		var files = frm.importfile.files;
		for (var i = 0; i < files.length; i++)
		{
			var file = files[i];
			formData.append('incafiles[]', file, file.name);
		}

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportInca';
		url += '&exportdate='+encodeURIComponent(exportDate);

		// POST
		Wizard.showLoadingAnimation('Importing INCA data...', 'inca-import-progress');
		Wizard.asyncJsonRequest(url, iport.submissionResults, 'POST', formData);
	}

	iport.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('downloadreportfile');
		Doc.show('downloadoutputfile');
		Doc.show('gorestart');
	}

	return iport;
}();

Doc.onLoad(Iport.initPage);

