<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Formatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~extraction_registration.js" 
	styles="path.css,~../css/reggie-2.css"
	>
<style>
tr.highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}

#detailsTable
{
	width: 100%; 
	border-collapse: collapse;
	border-bottom-width: 1px;
	border-top-width: 1px;
}

#detailsTable td, #detailsTable th
{
	text-align: center;
	min-width: 5%;
	padding: 2px;
}

#detailsTable .comment
{
	min-width: 10%;
}

#detailsTable .italic
{
	font-style: italic;
}

#detailsTable .low-conc
{
	background-image: url('../images/warning_small.png');
	background-repeat: no-repeat;
	background-position: 98% 50%;
}

.nondefault
{
	background: #FFF066;
}
.nondefault:after
{
	content: '›';
}
.nondefault:before
{
	content: '‹';
}
span.status
{
	width: 20px;
	float: right;
}
.specimen, .label
{
	white-space: nowrap;
}

.nolabels .label
{
	display: none;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="DNA/RNA/FlowThrough registration" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">

	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select unprocessed lysate items</div>
		<div class="step-content">
	
			<table class="step-form">
			<tr class="align-top" id="regularFlowRow">
				<td class="prompt">Lysates<div style="font-weight: normal;">(regular flow)</div></td>
				<td class="input">
					<select name="lysates" id="lysates" class="yellow-label-support" multiple size="15" data-current-user="<%=HTML.encodeTags(user.getName())%>"></select>
				</td>
				<td class="status" id="lysates.status"></td>
				<td class="help">
					<span id="lysates.message" class="message" ></span>
					Select 1-12 items. The list contain Lysate items that has not yet been processed
					(determined by absence of a 'creation' date).<br>
					<base:icon image="<%=home+"/images/yellow-label.png"%>" /> = YellowLabel specimen
				</td>
			</tr>
			<tr class="align-top" id="reExtractionRow" style="display: none;">
				<td class="prompt">Lysates<div style="font-weight: normal;">(re-extraction)</div></td>
				<td class="input">
					<select name="reextraction" id="reextraction" multiple size="12" class="yellow-label-support"></select>
					<b>Download labels</b>
					<base:icon subclass="link" id="downloadLabelsCsv" image="<%=home + "/images/download.png"%>" 
						data-format="csv" title="Download labels as a tab-separated text file (csv)">CSV</base:icon>
					<base:icon subclass="link" id="downloadLabelsXlsx" image="<%=home + "/images/download.png"%>" 
						data-format="xlsx" title="Download lables as an Excel worksheet file (xlsx)">Excel</base:icon>
				</td>
				<td class="status" id="reextraction.status"></td>
				<td class="help">
					<span id="reextraction.message" class="message"></span>
					Select lysates that have been marked for re-extraction to include in this extraction.
					<b>Download labels</b> in either <b>CSV</b> or <b>Excel</b> format for creating labels.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<!-- 2. Lysis + Qiacube information -->
	<div class="step auto-hide" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Common information from Lysate and QIAcube step</div>
		<div class="step-content">
		
			<table class="step-form">
			<tbody class="section-header">
				<tr>
					<td colspan="4">Lysis <span id="only-re-extraction"></span></td>
				</tr>
			</tbody>
			<tr>
				<td class="prompt">Date</td>
				<td class="input">
					<input type="text" name="lysisDate" id="lysisDate"
						value="<%=dateFormat.format(new Date()) %>" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="lysisProtocol"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="lysisDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="lysisDate"
							data-date-format="yyyyMMdd"
							data-title="Lysis date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="lysisDate.status"></td>
				<td class="help">
					<span id="lysisDate.message" class="message"></span>
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td class="input">
					<select name="lysisProtocol" id="lysisProtocol" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="rltPlusBuffer"
					></select>
				</td>
				<td class="status" id="lysisProtocol.status"></td>
				<td class="help">
					<span id="lysisProtocol.message" class="message"></span>
					Select the protocol which was used in the lysis step.
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="rltPlusBuffer.title">RLT Plus buffer</td>
				<td class="input">
					<input type="text" name="rltPlusBuffer" id="rltPlusBuffer" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="betaMercaptoetanol"
						maxlength="255">
				</td>
				<td class="status" id="rltPlusBuffer.status"></td>
				<td class="help">
					<span id="rltPlusBuffer.message" class="message"></span>
					Lot numbers for the reagents used.
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="betaMercaptoetanol.title">Beta-Mercaptoetanol</td>
				<td class="input">
					<input type="text" name="betaMercaptoetanol" id="betaMercaptoetanol" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="reagentDx"
						maxlength="255">
				</td>
				<td class="status" id="betaMercaptoetanol.status"></td>
				<td class="help">
					<span id="betaMercaptoetanol.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="reagentDx.title">Reagent DX</td>
				<td class="input">
					<input type="text" name="reagentDx" id="reagentDx" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiaShredderColumn"
						maxlength="255">
				</td>
				<td class="status" id="reagentDx.status"></td>
				<td class="help">
					<span id="reagentDx.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="qiaShredderColumn.title">QIAshredder column</td>
				<td class="input">
					<input type="text" name="qiaShredderColumn" id="qiaShredderColumn" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeDate"
						maxlength="255">
				</td>
				<td class="status" id="qiaShredderColumn.status"></td>
				<td class="help">
					<span id="qiaShredderColumn.message" class="message"></span>
				</td>
			</tr>
			<tr id="useLatestLysateReagents" style="display: none;">
				<td class="prompt"></td>
				<td class="input">
					<base:button id="btnUseLatestLysateReagents"
						title="Use latest lot numbers" data-which="lysate" />
						<span id="latestLysisDate"></span>
				</td>
				<td class="status"></td>
				<td class="help">
					Click on the button to automatically fetch
					and fill in reagent lot numbers from the latest
					QIAcube run.
				</td>
			</tr>
			<tbody class="section-header">
				<tr>
					<td colspan="4">QIAcube</td>
				</tr>
			</tbody>
			<tr>
				<td class="prompt">Date</td>
				<td class="input">
					<input type="text" name="qiacubeDate" id="qiacubeDate"
						value="<%=dateFormat.format(new Date()) %>" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeRunNo"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="qiacubeDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="qiacubeDate"
							data-date-format="yyyyMMdd"
							data-title="QIAcube date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="qiacubeDate.status"></td>
				<td class="help">
					<span id="qiacubeDate.message" class="message"></span>
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="prompt">Run number</td>
				<td class="input">
					<input type="text" name="qiacubeRunNo" id="qiacubeRunNo"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeOperator"
						style="width: 8em;" maxlength="10" value="1">
				</td>
				<td class="status" id="qiacubeRunNo.status"></td>
				<td class="help"><span id="qiacubeRunNo.message" class="message"></span></td>
			</tr>
			<tr>
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="qiacubeOperator" id="qiacubeOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="dnaProtocol"
						value="<%=HTML.encodeTags(user.getName()) %>" maxlength="255">
				</td>
				<td class="status" id="qiacubeOperator.status"></td>
				<td class="help">
					<span id="qiacubeOperator.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="prompt">DNA protocol</td>
				<td class="input">
					<select name="dnaProtocol" id="dnaProtocol"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="rnaProtocol"
					></select>
				</td>
				<td class="status" id="dnaProtocol.status"></td>
				<td class="help">
					<span id="dnaProtocol.message" class="message"></span>
					Select the protocol which was used for DNA extraction.
				</td>
			</tr>
			<tr>
				<td class="prompt">RNA protocol</td>
				<td class="input">
					<select name="rnaProtocol" id="rnaProtocol"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="ftProtocol"
					></select>
				</td>
				<td class="status" id="rnaProtocol.status"></td>
				<td class="help">
					<span id="rnaProtocol.message" class="message"></span>
					Select the protocol which was used for RNA extraction.
				</td>
			</tr>
			<tr>
				<td class="prompt">FlowThrough protocol</td>
				<td class="input">
					<select name="ftProtocol" id="ftProtocol"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="allPrepMiniKit"
					></select>
				</td>
				<td class="status" id="ftProtocol.status"></td>
				<td class="help">
					<span id="ftProtocol.message" class="message"></span>
					Select the protocol which was used for FlowThrough extraction.
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="allPrepMiniKit.title">AllPrep DNA/RNA Mini kit</td>
				<td class="input">
					<input type="text" name="allPrepMiniKit" id="allPrepMiniKit" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="etoh70"
						maxlength="255">
				</td>
				<td class="status" id="allPrepMiniKit.status"></td>
				<td class="help">
					<span id="allPrepMiniKit.message" class="message"></span>
					Lot numbers for the reagents used.
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="etoh70.title">ETOH 70%</td>
				<td class="input">
					<input type="text" name="etoh70" id="etoh70" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="bufferRw1"
						maxlength="255">
				</td>
				<td class="status" id="etoh70.status"></td>
				<td class="help">
					<span id="etoh70.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="bufferRw1.title">Buffer RW1</td>
				<td class="input">
					<input type="text" name="bufferRw1" id="bufferRw1" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="bufferRpe"
						maxlength="255">
				</td>
				<td class="status" id="bufferRw1.status"></td>
				<td class="help">
					<span id="bufferRw1.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="bufferRpe.title">Buffer RPE</td>
				<td class="input">
					<input type="text" name="bufferRpe" id="bufferRpe" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="bufferAw1"
						maxlength="255">
				</td>
				<td class="status" id="bufferRpe.status"></td>
				<td class="help">
					<span id="bufferRpe.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="bufferAw1.title">Buffer AW1</td>
				<td class="input">
					<input type="text" name="bufferAw1" id="bufferAw1" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="bufferAw2"
						maxlength="255">
				</td>
				<td class="status" id="bufferAw1.status"></td>
				<td class="help">
					<span id="bufferAw1.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="bufferAw2.title">Buffer AW2</td>
				<td class="input">
					<input type="text" name="bufferAw2" id="bufferAw2" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="bufferEb"
						maxlength="255">
				</td>
				<td class="status" id="bufferAw2.status"></td>
				<td class="help">
					<span id="bufferAw2.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="bufferEb.title">Buffer EB</td>
				<td class="input">
					<input type="text" name="bufferEb" id="bufferEb" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="rnaseFreeWater"
						maxlength="255">
				</td>
				<td class="status" id="bufferEb.status"></td>
				<td class="help">
					<span id="bufferEb.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="rnaseFreeWater.title">RNase free water</td>
				<td class="input">
					<input type="text" name="rnaseFreeWater" id="rnaseFreeWater" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="allPrepDnaColumn"
						maxlength="255">
				</td>
				<td class="status" id="rnaseFreeWater.status"></td>
				<td class="help">
					<span id="rnaseFreeWater.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="allPrepDnaColumn.title">AllPrep DNA Mini Spin Column</td>
				<td class="input">
					<input type="text" name="allPrepDnaColumn" id="allPrepDnaColumn" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="rneasyColumn"
						maxlength="255">
				</td>
				<td class="status" id="allPrepDnaColumn.status"></td>
				<td class="help">
					<span id="allPrepDnaColumn.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="subprompt" id="rneasyColumn.title">RNeasy Mini Spin Column</td>
				<td class="input">
					<input type="text" name="rneasyColumn" id="rneasyColumn" 
						maxlength="255">
				</td>
				<td class="status" id="rneasyColumn.status"></td>
				<td class="help">
					<span id="rneasyColumn.message" class="message"></span>
				</td>
			</tr>
			<tr id="useLatestRnaReagents" style="display: none;">
				<td class="prompt"></td>
				<td class="input">
					<base:button id="btnUseLatestRnaReagents"
						title="Use latest lot numbers" data-which="rna" />
						<span id="latestQiacubeDate"></span>
				</td>
				<td class="status"></td>
				<td class="help">
					Click on the button to automatically fetch
					and fill in reagent lot numbers from the latest
					QIAcube run.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<!-- 3. DNA/RNA/FT information -->
	<div class="step" id="step-3">
		<div class="step-no">3</div>
		<div class="step-title">RNA/DNA/FlowThrough details</div>
		<div class="step-content">
		
			<div class="bg-filled-50" style="padding: 4px;">
				The table below show values from the QIAcube run.
				<span class="nondefault">Highlighted</span> values have been manually 
				changed from their default values. If the QIAcube positions are not correct,
				they must be fixed before the <i>NanoDrop Sample ID</i> file is downloaded
				since the order in this file depends on the positions. The concentrations
				and other values are loaded from the file after the NanoDrop has been completed.
			</div>
			<div id="label-info" class="bg-filled-50" style="padding: 0 4px 4px 4px; display: none;">
				¹ Some SCAN-B tubes have a non-standard label.
			</div>

			<div id="detailsSection" class="nolabels"></div>

			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">NanoDrop Sample ID</td>
				<td class="input">
					<base:button id="downloadSampleIdFile" title="Download..."
						image="<%=home + "/images/download.png"%>" style="width:10em;" />
				</td>
				<td class="status" id="downloadSampleIdFile.status"></td>
				<td class="help">
					<span id="downloadSampleIdFile.message" class="message"></span>
					Download and import this file to the NanoDrop software before analyzing the DNA/RNA.
					<b>Note that the samples are sorted by QIAcube position!</b>
				</td>
			</tr>
			<tr>
				<td class="prompt">NanoDrop values</td>
				<td class="input">
					<input type="file" name="nanoDropFile" id="nanoDropFile" class="required" style="width: 95%;" accept="text/plain">
				</td>
				<td class="status" id="nanoDropFile.status"></td>
				<td class="help">
					<span id="nanoDropFile.message" class="message"></span>
					Select the file containing measurements from the NanoDrop.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td><base:button id="rnaQcWizard" title="Continue with RNA QC registration on Caliper plate" image="<%=home+"/images/gonext.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	
	<div id="debug-tools">
		<base:button 
			id="btnFakeNanoFropFile" 
			title="Fake NanoDrop file..." 
			tooltip="Generates fake data for all NanoDrop measurements."
			image="bug.png"
		/>
	</div>
	
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>