<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	int listId = Values.getInt(request.getParameter("transportBox"));
	
	ItemList transportBox = ItemList.getById(dc, listId);
	ItemSubtype subtype = transportBox.getItemSubtype();
	String view = Values.getString(request.getParameter("view"), "list");
	String title = "Lab protocol for " + HTML.encodeTags(transportBox.getName()) + " - " + (view.equals("list") ? "list" : "box");

	int columns = 9;
	int rows = 9;
%>
<base:page id="protocol" type="iframe" favicon="<%=home+"/images/specimen.png"%>" title="<%=title%>" noskin="true">
<base:head
	scripts="~../reggie-2.js,~storagebox.js,~move_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css,~../css/plate.css"
	>
	<style>
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		border-collapse: collapse;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: top;
		height: 1.25em;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 4px;
		width: 25%;
	}
	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 4px;
		width: 25%;
	}
	
	.protocolNote
	{
		margin-top: 0.25em;
		margin-bottom: 1em;
	}
	
	#listview
	{
		width: 100%;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	#listview thead
	{
		border: 1px solid #000000;
		background-color: #E0E0E0;
	}
	
	#listview tbody
	{
		border-top: 1px solid #000000;
		border-bottom: 1px solid #000000;
	}
	
	#listview th
	{
		border-left: 1px solid #000000;
		padding: 0.25em;
	}
	
	#listview td
	{
		border-left: 1px solid #000000;
		border-top: 1px dotted #666666;
		vertical-align: middle;
		text-align: center;
		padding: 1px;
	}

	#listview .odd-row
	{
		background-color: #E8E8E8;
	}
	
	#listview .location
	{
		border-left: 0;
	}
	
	#listview .comment
	{
		width: 30%;
	}

	/* Divide the 9 wells across the full page */
	.storagebox .well
	{
		width: 11%;
		max-width: 11%;
		min-width: 11%;
		font-size: 90%;
		height: 3em;
		background-color: #FFFFFF;
		padding: 4px;
		vertical-align: top;
		text-align: center;
		border-style: solid;
	}
	
	.storagebox .well.not-empty
	{
		height: 9em;
	}
	
	.storagebox .well.locked
	{
		color: #999999;
		background-color: #F0F0F0;
		vertical-align: middle;
		text-align: center;
		font-weight: bold;
		font-size: 125%;
		height: 2em;
	}
	
	.storagebox .box-name
	{
		padding: 0.5em;
	}
	
	.major-ref
	{
		font-weight: bold;
		padding: 0.1em 0.5em;
		margin: 0.25em;
		display: inline-block;
		border-width: 1px;
		border-radius: 1em;
	}
	
	.storagebox .major-ref
	{
		font-size: 115%;
		padding: 0.5em 1em;
	}
	
	.storagebox .well:hover
	{
		padding: 3px;
	}
		
	.storagebox .rowheader
	{
		width: 2em;
	}
	
	.more-boxes
	{
		font-weight: bold;
		text-align: right;
		page-break-after: always;
	}
	</style>
</base:head>
<base:body>

	<div class="paper">

	<form name="reggie" id="wizard">
	
	<div id="page-data" class="datacontainer"
		data-view="<%=view%>"
		data-transport-box="<%=listId %>"
		data-home-url="<%=home%>"
	></div>
	
	<div id="wizard-status"></div>

	<div id="all-protocol" style="display: none;">
	<div id="print-instructions" class="noprint fullwidth">
		<base:button id="print-button" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<span id="printNote">
		<b>Note!</b> 
		<%
		if (view.equals("list"))
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. To fit everything on a single page, scale down to <i>60-70%</i>.
			<%
		}
		else
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. The recommended scale is <i>100%</i>.
			<%
		}
		%>
		</span>
		<br clear="all">
	</div>

	
	<h1>Lab protocol for moving samples to storage boxes <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<table style="width: 100%;" class="protocolheader">
	<tr>
		<th>Transport box</th>
		<td id="boxName"><%=HTML.encodeTags(transportBox.getName())%></td>
		<th class="leftborder" style="width: 15%;">Date</th>
		<td style="width: 25%;"></td>
	</tr>
	<tr class="topborder">
		<th>Sample type</th>
		<td><%=subtype!=null?HTML.encodeTags(subtype.getName()) : "<i>Unknown</i>"%></td>
		<td rowspan="3" colspan="2" class="leftborder" style="width: 40%;">
			<%=HTML.encodeTags(transportBox.getDescription())%>
		</td>
	</tr>
	<tr class="topborder">
		<th>Number of samples</th>
		<td><%=transportBox.getSize()%></td>
	</tr>
	<tr class="topborder">
		<th>SCAN-B box and freezer</th>
		<td id="storageBoxes"></td>
	</tr>
	<tr class="topborder" style="height: 4em;">
		<th>Clarity ID of extra tubes¹</th>
		<td colspan="3"></td>
	</tr>
	</table>
	<div class="protocolNote">
	¹ Please note the Clarity ID of all extra tubes (if there are any) 
	in the box that are not mentioned in this protocol.
	</div>
	
	<div id="transportMessages"></div>

	<%
	if (view.equals("list"))
	{
		%>
		<table style="width: 100%;" id="listview">
		<thead>
			<tr class="toprow">
				<th class="clarityId">Clarity ID</th>
				<th class="specimen">SCAN-B Specimen</th>
				<th class="box" colspan="2">Storage box</th>
				<th class="remain">Remain</th>
				<th>Comments</th>
			</tr>
		</thead>
		<tbody id="listData"></tbody>
		</table>
		<%
	}
	else
	{
		// We create two storage boxes (hidden) The will be displayed
		// by the script if needed
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		for (int boxNo = 1; boxNo <=2; boxNo++)
		{
			%>
			<table id="box.<%=boxNo%>" class="plate storagebox" style="margin: 1em 0; width: 100%; display: none;">
			<tr class="header">
				<th colspan="11" id="box.<%=boxNo%>.name" class="box-name"></th>
			</tr>
			<tr class="header">
				<th></th>
				<%
				for (int c = 0; c < columns; ++c)
				{
					%>
					<th id="box.<%=boxNo%>.col.<%=c%>"><%=colF.format(c)%></th>
					<%
				}
				%>
				<th style="border-bottom: 0;"></th>
			</tr>
			<tbody>
			<%
			for (int r = 0; r < rows; ++r)
			{
				String row = rowF.format(r);
				%>
				<tr class="row-<%=r%> empty-row" id="box.<%=boxNo%>.row.<%=r%>">
					<th class="rowheader"><%=row%></th>
					<%
					for (int c = 0; c < columns; ++c)
					{
						%>
						<td class="well col-<%=c%>" id="box.<%=boxNo%>.well.<%=r%>.<%=c%>"></td>
						<%
					}
					%>
					<th class="rowheader"><%=row%></th>
				</tr>
				<%
			}
			%>
			</tbody>
			<tr class="footer">
				<th></th>
				<%
				for (int c = 0; c < columns; ++c)
				{
					%>
					<th id="box.<%=boxNo%>.col.<%=c%>"><%=colF.format(c)%></th>
					<%
				}
				%>
				<th style="border-top: 0;"></th>
			</tr>
			</table>
			<div id="box.<%=boxNo%>.more-boxes" class="more-boxes" style="display: none;">
				Continued on next page...
			</div>
			<%
		}
	}
	%>
</div>
</form>
</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>