<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Formatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~move_registration.js" 
	styles="path.css,~../css/reggie-2.css"
>
<style>
#select-missing-sample
{
	width: 25em; 
	z-index: 2; 
}
#missing-samples-list
{
	max-height: 40em;
	overflow: auto;
}

#missing-samples-list .menuitem
{
	padding-left: 18px;
}

#missing-samples-list .is-selected
{
	background-image: url('../images/selected.gif');
	background-position: 2px 50%;
	background-repeat: no-repeat;
}

#missing-samples-list .menuitem:hover
{
	padding-left: 16px;
	background-position: 0px 50%;
}

#missing-samples-list b
{
	border-width: 1px;
	border-radius: 0.5em;
	background-color: white;
	padding: 2px;
	margin: 1px;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register moved samples" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	<div id="select-missing-sample" class="menu vertical bg-filled-100" style="display: none;">
		<div id="missing-samples-list"></div>
	</div>
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select Transport box</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Transport box</td>
				<td class="input">
					<select name="transportBox" id="transportBox" class="required"></select>
				</td>
				<td class="status" id="transportBox.status"></td>
				<td class="help" rowspan="2">
					<span id="transportBox.message" class="message"></span>
					Select an existing Transport box. The list contain all transport boxes that
					has not yet been registered as completed.
				</td>
			</tr>
			<tbody class="info-section">
			<tr>
				<td class="prompt">Comments</td>
				<td class="info" id="boxComments"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</tbody>
			</table>
		</div>
	</div>

	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Register information about the move</div>
		<div class="step-content">
			<table class="step-form">
			<tr>
				<td class="prompt">Date</td>
				<td class="input">
					<input type="text" name="moveDate" id="moveDate"
						value="<%=dateFormat.format(new Date()) %>" 
						class="auto-init required" data-auto-init="focus-on-enter" data-next-focus="moveOperator"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="moveDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="moveDate"
							data-date-format="yyyyMMdd"
							data-title="Move date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="moveDate.status"></td>
				<td class="help">
					<span id="moveDate.message" class="message"></span>
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="moveOperator" id="moveOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="missingSamples"
						value="<%=HTML.encodeTags(user.getName()) %>" maxlength="255">
				</td>
				<td class="status" id="moveOperator.status"></td>
				<td class="help">
					<span id="moveOperator.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="prompt">Missing samples</td>
				<td class="input">
					<label><input type="checkbox" name="noMissingSamples" id="noMissingSamples" value="none" checked>None</label>
					<i>- or -</i> 
					<base:button id="showMissingSampleMenu" subclass="icon-to-right"
						title="<i>- select -</i>" image="sort_asc.png" tooltip="Select missing samples" /><br>
					<textarea name="missingSamples" id="missingSamples" rows="3"></textarea>
				</td>
				<td class="status" id="missingSamples.status"></td>
				<td class="help">
					<span id="missingSamples.message" class="message"></span>
					Check the <b>None</b> option if all samples was found in the transport box 
					and moved to the SCAN-B box.<br>
					Otherwise, specify the <b>Clarity ID</b> of the
					missing samples. Each ID should be separated by a comma, space or newline.
				</td>
			</tr>
		
			<tr class="align-top">
				<td class="prompt">Extra samples in the box</td>
				<td class="input">
					<textarea name="extraSamples" id="extraSamples" rows="3"></textarea>
				</td>
				<td class="status" id="extraSamples.status"></td>
				<td class="help">
					<span id="extraSamples.message" class="message"></span>
					Enter the <b>Clarity ID</b> of extra samples in the transport
					box that was not mentioned in the manifest. Each ID should be
					separated by a comma, space or newline.
				</td>
			</tr>

			<tr class="align-top">
				<td class="prompt">Other comments</td>
				<td class="input">
					<textarea name="comments" id="comments" rows="3"></textarea>
				</td>
				<td class="status" id="comments.status"></td>
				<td class="help">
					<span id="comments.message" class="message"></span>
					Other comments about the move.
				</td>
			</tr>

				
			</table>
		
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>