<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" title="Paused specimen wizard">
<base:head 
	scripts="~../reggie-2.js,~paused-specimen.js" 
	styles="path.css,toolbar.css,~../css/reggie-2.css"
	>
<style>
#specimenTable
{
	width: 100%; 
	border-collapse: collapse;
}

#specimenTable thead
{
	border-bottom-width: 1px;
	border-top-width: 1px;
}

#specimenTable .highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}

#specimenTable .highlight.evenrow
{
	border-top-color: transparent;
}

#specimenTable td, #specimenTable th
{
	text-align: center;
	width: 12em;
}

#specimenTable tbody td
{
	padding-top: 1px;
	padding-bottom: 1px;
}

#specimenTable tr td:first-child, #specimenTable tr th:first-child
{
	width: 7em;
	text-align: right;
	padding-right: 0.5em;
	white-space: nowrap;
	font-weight: bold;
}

#specimenTable input[type="text"], #specimenTable select
{
	width: calc(100% - 10px);
}

#specimenTable .case-summary
{
	margin-left: 4px;
	float: right;
}

#specimenTable .if-yellow
{
	padding-left: 18px;
}

#specimenTable .yellow-specimen .if-yellow
{
	background-image: url('../images/yellow-label.png');
	background-repeat: no-repeat;
	background-position: 2px 50%;
}

#pausedInfo
{
	border-right-width: 0;
	padding-left: 1em;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Paused specimen wizard" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select specimen items (found <span id="num-matching">?</span>)</div>
		<div class="step-content">
	
			<tbl:toolbar subclass="bg-filled-50">
				<tbl:button 
					id="btnExtractSpecimen"
					image="<%=home + "/images/partition.png"%>"
					title="Schedule for extraction"
					tooltip="The selected specimen items will be scheduled for extraction"
				/>
				<tbl:button 
					id="btnPauseSpecimen"
					image="<%=home + "/images/pause.png"%>"
					title="Pause specimen"
					tooltip="The selected specimen items will be paused (again)"
				/>
				<tbl:button 
					id="btnPauseSettings"
					image="<%=home + "/images/install.png"%>"
					title="Settings&hellip;"
					tooltip="Select sites that should be paused by default"
				/>
				<tbl:label id="pausedInfo" clazz="" />
			</tbl:toolbar>

			<table id="specimenTable">
			<thead class="bg-filled-100">
				<tr>
					<th></th>
					<th class="dottedleft">Name</th>
					<th>Status</th>
					<th>Site</th>
					<th>Sampling date</th>
					<th>Arrival date</th>
					<th>Storage box</th>
					<th style="width: auto;"></th>
				</tr>

				<tr>
					<th><base:icon image="check_uncheck.png" id="check_uncheck" /></th>
					<th class="dottedleft"><input type="text" name="nameFilter" id="nameFilter"></th>
					<th>
						<select name="statusFilter" id="statusFilter">
							<option value="">&nbsp;
							<option value="Disable">Paused
							<option value="ReProcess">Scheduled
						</select>
					</th>
					<th>
						<select name="siteFilter" id="siteFilter">
							<option value="">&nbsp;
						</select>
					</th>
					<th><input type="text" name="samplingDateFilter" id="samplingDateFilter"></th>
					<th><input type="text" name="arrivalDateFilter" id="arrivalDateFilter"></th>
					<th><input type="text" name="storageBoxFilter" id="storageBoxFilter"></th>
					<th style="width: auto;"></th>
				</tr>

			</thead>
			<tbody id="specimen-list">
			</tbody>
			<tbody id="no-match" style="display: none;" class="topborder">
				<tr>
					<td></td>
					<td colspan="6" class="dottedleft" style="width: auto; font-weight: bold; text-align: left; padding: 1em;">
						Could not find any specimen items.
					</td>
				</tr>
			</tbody>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>