var StorageBox = function()
{
	var box = {};
	var debug = 0;
	
	var nofBoxesIsValid = [];
	
	var lastSpBox;
	var lastPSpBox;
	var lastESpBox;
	var newBoxes;
	
	// Page initialization
	box.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', box.validateStep1);
		Events.addEventHandler('numberOfSpBoxes', 'keypress', Events.integerOnly);
		Events.addEventHandler('numberOfSpBoxes', 'blur', box.nofBoxesOnChange);
		Events.addEventHandler('numberOfPSpBoxes', 'keypress', Events.integerOnly);
		Events.addEventHandler('numberOfPSpBoxes', 'blur', box.nofBoxesOnChange);
		Events.addEventHandler('numberOfESpBoxes', 'keypress', Events.integerOnly);
		Events.addEventHandler('numberOfESpBoxes', 'blur', box.nofBoxesOnChange);

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', box.initializeStep2);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		Buttons.addClickHandler('downloadLabelsCsv', box.downloadLabels);
		Buttons.addClickHandler('downloadLabelsXlsx', box.downloadLabels);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', box.submit);

		Reggie.loadHardware('FREEZER', 'freezer');

		// Load last storage box
		var url = '../SpecimenTubeRegistration.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLastExistingStorageBoxes'
		Wizard.showLoadingAnimation('Loading existing storage boxes...');
		Wizard.asyncJsonRequest(url, box.lastBoxLoaded);
	}

	box.lastBoxLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		lastSpBox = response.lastSpBox;
		lastPSpBox = response.lastPSpBox;
		lastESpBox = response.lastESpBox;
		
		var counts = response.counts;
		var emptySpBoxes = counts['empty-storage-boxes'];
		var emptyPSpBoxes = counts['empty-paused-storage-boxes'];
		var emptyESpBoxes = counts['empty-external-storage-boxes'];
		
		var focus = null;
		if (lastSpBox)
		{
			Doc.element('lastSpBox').innerHTML = Strings.encodeTags(lastSpBox.name) + ' (' + lastSpBox.freeWells + ' free wells)';
		}
		if (emptySpBoxes != null) 
		{
			Doc.element('emptySpBoxes').innerHTML = emptySpBoxes;
			if (emptySpBoxes < 2) 
			{
				frm.numberOfSpBoxes.value = '8';
				if (focus == null) focus = frm.numberOfSpBoxes;
			}
		}
		
		if (lastPSpBox)
		{
			Doc.element('lastPSpBox').innerHTML = Strings.encodeTags(lastPSpBox.name) + ' (' + lastPSpBox.freeWells + ' free wells)';
		}
		if (emptyPSpBoxes != null) 
		{
			Doc.element('emptyPSpBoxes').innerHTML = emptyPSpBoxes;
			if (emptyPSpBoxes < 2) 
			{
				frm.numberOfPSpBoxes.value = '8';
				if (focus == null) focus = frm.numberOfPSpBoxes;
			}
		}

		if (lastESpBox)
		{
			Doc.element('lastESpBox').innerHTML = Strings.encodeTags(lastESpBox.name) + ' (' + lastESpBox.freeWells + ' free wells)';
			if (lastESpBox.freezer) Forms.selectListOption('freezer', lastESpBox.freezer);
		}
		if (emptyESpBoxes != null) 
		{
			Doc.element('emptyESpBoxes').innerHTML = emptyESpBoxes;
			if (emptyESpBoxes < 2) 
			{
				frm.numberOfESpBoxes.value = '8';
				if (focus == null) focus = frm.numberOfESpBoxes;
			}
		}

		nofBoxesIsValid['numberOfSpBoxes'] = true;
		nofBoxesIsValid['numberOfPSpBoxes'] = true;
		nofBoxesIsValid['numberOfESpBoxes'] = true;
		
		Doc.show('step-1');
		Doc.show('gonext');
		if (focus != null) focus.focus();
	}
	
	box.validateStep1 = function(event)
	{
		var frm = document.forms['reggie'];
		if (!nofBoxesIsValid['numberOfSpBoxes']) event.preventDefault();
		if (!nofBoxesIsValid['numberOfPSpBoxes']) event.preventDefault();
		if (!nofBoxesIsValid['numberOfESpBoxes']) event.preventDefault();
		
		var nofSpBoxes = parseInt(frm.numberOfSpBoxes.value);
		var nofPSpBoxes = parseInt(frm.numberOfPSpBoxes.value);
		var nofESpBoxes = parseInt(frm.numberOfESpBoxes.value);
		if (nofSpBoxes == 0 && nofPSpBoxes == 0 && nofESpBoxes == 0)
		{
			Wizard.showGoNextConfirmation(false, 'No new boxes to create!');
			event.preventDefault();
		}
	}
	
	box.nofBoxesOnChange = function(event)
	{
		var target = event.currentTarget;
		
		nofBoxesIsValid[target.id] = false;
		Wizard.hideGoNextConfirmation();
		
		var errmsg = box.checkNofBoxes(target.value);
		if (errmsg)
		{
			Wizard.setInputStatus(target.id, 'invalid', errmsg);
			return;
		}
		Wizard.setInputStatus(target.id, 'valid');
		nofBoxesIsValid[target.id] = true;
	}

	box.checkNofBoxes = function(nofBoxes)
	{
		if (nofBoxes == '') return 'Missing';
		if (parseInt(nofBoxes) < 0) return 'Must not be less than 0';
		if (parseInt(nofBoxes) > 99) return 'Must not be greater than 99';
		return null;
	}
	
	box.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];
		var nofSpBoxes = parseInt(frm.numberOfSpBoxes.value);
		var nofPSpBoxes = parseInt(frm.numberOfPSpBoxes.value);
		var nofESpBoxes = parseInt(frm.numberOfESpBoxes.value);
		
		if (nofSpBoxes == 0 && nofPSpBoxes == 0 && nofESpBoxes == 0)
		{
			Wizard.setFatalError('No new boxes to create!');
			return;
		}
		
		var endNo = Math.max(nofSpBoxes+nofESpBoxes, nofPSpBoxes);
		var baseSpNo = 1+(lastSpBox ? parseInt(lastSpBox.name.substring(2)) : 0);
		var basePSpNo = 1+(lastPSpBox ? parseInt(lastPSpBox.name.substring(3)) : 0);
		var baseESpNo = 1+(lastESpBox ? parseInt(lastESpBox.name.substring(4)) : 0);
		
		var html = '';
		var SpBoxPrefixes = ['Sp', 'PSp', 'Lys', 'RNA', 'DNA', 'FT'];
		var ESpBoxPrefixes = ['E-Sp', 'PSp', 'E-Lys', 'E-RNA', 'E-DNA', 'E-FT'];

		newBoxes = [];
		var createdSpBoxes = 0;
		var createdPSpBoxes = 0;
		var createdESpBoxes = 0;
		var maxPrefix = SpBoxPrefixes.length-1;
		for (var index = 1; index <= endNo; index++)
		{			
			html += '<tr>';
			for (var prefixNo = 0; prefixNo < SpBoxPrefixes.length; prefixNo++)
			{
				var boxName = null;
				if (prefixNo == 1)
				{
					if (createdPSpBoxes < nofPSpBoxes)
					{
						boxName = SpBoxPrefixes[prefixNo]+box.zeroPad(createdPSpBoxes+basePSpNo);
						createdPSpBoxes++;
					}
				}
				else
				{
					if (createdSpBoxes < nofSpBoxes)
					{
						boxName = SpBoxPrefixes[prefixNo]+box.zeroPad(createdSpBoxes+baseSpNo);
						if (prefixNo == maxPrefix) createdSpBoxes++;
					}
					else if (createdESpBoxes < nofESpBoxes)
					{
						boxName = ESpBoxPrefixes[prefixNo]+box.zeroPad(createdESpBoxes+baseESpNo);
						if (prefixNo == maxPrefix) createdESpBoxes++;
					}
				}
				if (boxName != null)
				{
					newBoxes[newBoxes.length] = boxName;
					html += '<td>'+boxName+'</td>';
				}
				else
				{
					html += '<td></td>';
				}				
			}
			html += '</tr>';
		}
		Doc.element('new-boxes').innerHTML = html;
		
		Wizard.setCurrentStep(2);
		Doc.show('goregister');
		Doc.show('gocancel');
		Doc.show('godownload');
		Wizard.showGoNextConfirmation(true, 'I have downloaded the label file');
	}
	
	box.zeroPad = function(boxNo)
	{
		var zeroPad = '';
		if (boxNo < 10) zeroPad = '00';
		else if (boxNo < 100) zeroPad = '0';
		return zeroPad+boxNo;
	}
	
	box.downloadLabels = function(event)
	{
		var format = Data.get(event.currentTarget, 'format');
		Wizard.hideGoNextConfirmation();
		var url = '../SpecimenTubeRegistration.servlet?ID='+App.getSessionId();
		url += '&cmd=GetStorageBoxLabels';
		url += '&boxes='+newBoxes.join(',');
		url += '&format='+encodeURIComponent(format);
		window.open(url);
	}

	box.submit = function()
	{
		var frm = document.forms['reggie'];
		
		var submitInfo = {};
		
		if (lastSpBox) submitInfo.lastSpBox = lastSpBox.id;
		submitInfo.nofSpBoxes = parseInt(frm.numberOfSpBoxes.value);

		if (lastPSpBox) submitInfo.lastPSpBox = lastPSpBox.id;
		submitInfo.nofPSpBoxes = parseInt(frm.numberOfPSpBoxes.value);

		if (lastESpBox) submitInfo.lastESpBox = lastESpBox.id;
		submitInfo.nofESpBoxes = parseInt(frm.numberOfESpBoxes.value);
		submitInfo.freezer = parseInt(frm.freezer.value);
		
		var url = '../SpecimenTubeRegistration.servlet?ID='+App.getSessionId();
		url += '&cmd=CreateStorageBoxes';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, box.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	box.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}


	return box;
}();

Doc.onLoad(StorageBox.initPage);

