<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.DbControl"	
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~storage-box.js" 
	styles="path.css,~../css/reggie-2.css"
>
<style>

#box-table
{
	margin: 1em auto;
	border-collapse: collapse;
}

#box-table td, #box-table th
{
	width: 8em;
	text-align: center;
	padding: 2px 0.25em;
}

.wizard .step-form .subprompt
{
	text-align: left;
	padding-left: 2em;
}

</style>

</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Storage box creation wizard" 
		/></p:path>
	
	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Create storage boxes</div>
		<div class="step-content">
	
			<table class="step-form">
			<tr class="section-header">
				<td colspan="4">Storage boxes for regular processing</td>
			</tr>
			<tr>
				<td class="subprompt">Number of empty boxes</td>
				<td class="info" id="emptySpBoxes" colspan="2">-</td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Last existing box</td>
				<td class="info" id="lastSpBox" colspan="2">-</td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Number of new boxes</td>
				<td class="input">
					<input type="text" name="numberOfSpBoxes" id="numberOfSpBoxes"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="numberOfPSpBoxes"
						style="width: 12em;" maxlength="2" value="0">
				</td>
				<td class="status" id="numberOfSpBoxes.status"></td>
				<td class="help">
					<span id="numberOfSpBoxes.message" class="message"></span>
					Number of boxes to create (of each type): Sp*, Lys*, RNA*, DNA* and FT*.
				</td>
			</tr>
			<tr class="section-header">
				<td colspan="4">Storage boxes for paused specimen</td>
			</tr>
			<tr>
				<td class="subprompt">Number of empty boxes</td>
				<td class="info" id="emptyPSpBoxes" colspan="2">-</td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Last existing box</td>
				<td class="info" id="lastPSpBox" colspan="2">-</td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Number of new boxes</td>
				<td class="input">
					<input type="text" name="numberOfPSpBoxes" id="numberOfPSpBoxes"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="numberOfESpBoxes"
						style="width: 12em;" maxlength="2" value="0">
				</td>
				<td class="status" id="numberOfPSpBoxes.status"></td>
				<td class="help">
					<span id="numberOfPSpBoxes.message" class="message"></span>
					Number of boxes to create for paused specimen: PSp*
				</td>
			</tr>
			<tr class="section-header">
				<td colspan="4">Storage boxes for externally processed specimen</td>
			</tr>
			<tr>
				<td class="subprompt">Number of empty boxes</td>
				<td class="info" id="emptyESpBoxes" colspan="2">-</td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Last existing box</td>
				<td class="info" id="lastESpBox" colspan="2">-</td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="subprompt">Number of new boxes</td>
				<td class="input">
					<input type="text" name="numberOfESpBoxes" id="numberOfESpBoxes"
						style="width: 12em;" maxlength="2" value="0">
				</td>
				<td class="status" id="numberOfESpBoxes.status"></td>
				<td class="help">
					<span id="numberOfESpBoxes.message" class="message"></span>
					Number of boxes to create (of each type): E-Sp*, E-Lys*, E-RNA*, E-DNA* and E-FT*.
				</td>
			</tr>
			<tr>
				<td class="subprompt">Freezer to use</td>
				<td class="input">
					<select name="freezer" id="freezer"></select>
				</td>
				<td class="status" id="freezer.status"></td>
				<td class="help">
					<span id="freezer.message" class="message"></span>
					Select the freezer where the boxes for external specimen should be stored.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">New boxes</div>
		<div class="step-content">
	
			<table class="step-form">
			<tr>
				<td class="info" colspan="3">
					<table id="box-table">
						<thead class="fullborder bg-filled-100">
						<tr>
							<th>Specimen</th>
							<th>Paused</th>
							<th>Lysate</th>
							<th>RNA</th>
							<th>DNA</th>
							<th>FlowThrough</th>
						</tr>
						</thead>
						<tbody id="new-boxes" class="fullborder"></tbody>
						<tbody>
						<tr>
							<td colspan="5" style="text-align: left; padding-top: 1em;">
								<b>Download labels</b>
								<base:icon subclass="link" id="downloadLabelsCsv" image="<%=home + "/images/download.png"%>" 
									data-format="csv" title="Download labels as a tab-separated text file (csv)">CSV</base:icon>
								<base:icon subclass="link" id="downloadLabelsXlsx" image="<%=home + "/images/download.png"%>" 
									data-format="xlsx" title="Download lables as an Excel worksheet file (xlsx)">Excel</base:icon>
							</td>
						</tr>
						</tbody>
					</table>
					
				</td>
				<td class="help">
					This table list all boxes that are created. Do not forget to 
					<b>download labels</b> in either <b>CSV</b> or <b>Excel</b> 
					format for creating labels.
				</td>
			</tr>
			</table>
			
		</div>
	</div>
		
	<div id="wizard-status"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>