<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String pipeline = request.getParameter("pipeline");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Formatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~sequencing_external.js" 
	styles="path.css,~../css/reggie-2.css"
/>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register external sequencing" 
		/></p:path>

	<div id="page-data" class="datacontainer"
		data-pipeline="<%=HTML.encodeTags(pipeline)%>"
	></div>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">

	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Information about the sequencing</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Operator</td>
				<td class="input">
					<select name="operator" id="operator" class="required auto-init"
						data-auto-init="focus-on-enter" data-next-focus="libProtocol"
						>
						<option value="CTG">CTG
					</option>
				</td>
				<td class="status" id="operator.status"></td>
				<td class="help">
					<span id="operator.message" class="message"></span>
					The external operator.
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td class="input">
					<select name="libProtocol" id="libProtocol" class="required auto-init" 
						data-auto-init="focus-on-enter" data-next-focus="flowCellId"
						></select>
				</td>
				<td class="status" id="libProtocol.status"></td>
				<td class="help">
					<span id="libProtocol.message" class="message"></span>
					Select the protocol used for library preparation.
				</td>
			</tr>
			<tr>
				<td class="prompt">Flow cell ID</td>
				<td class="input">
					<input type="text" name="flowCellId" id="flowCellId"
						class="required auto-init" data-auto-init="focus-on-enter" data-next-focus="sampleSheetFile"
						style="width: 12em;">
				</td>
				<td class="status" id="flowCellId.status"></td>
				<td class="help">
					<span id="flowCellId.message" class="message"></span>
					The barcode of the flow cell.
				</td>
			</tr>
			<tr>
				<td class="prompt">Sample sheet</td>
				<td class="input">
					<input type="file" name="sampleSheetFile" id="sampleSheetFile" class="required" style="width: 95%;" accept="text/plain">
				</td>
				<td class="status" id="sampleSheetFile.status"></td>
				<td class="help">
					<span id="sampleSheetFile.message" class="message"></span>
					Select the file sample sheet for the sequencing.
				</td>
			</tr>
			<tr>
				<td class="prompt">Start date</td>
				<td class="input">
					<input type="text" name="startDate" id="startDate"
						class="auto-init required" data-auto-init="focus-on-enter" data-next-focus="comments"
						style="width: 12em;" maxlength="10">
				</td>
				<td class="status" id="startDate.status"></td>
				<td class="help">
					<span id="startDate.message" class="message"></span>
					Date when the sequencing started (YYYYMMDD)
				</td>
			</tr>
			<tr>
				<td class="prompt">Flow cell type</td>
				<td class="input">
					<label><input type="radio" name="flowCellType" id="flowCellTypeNovaSeq" checked value="NovaSeq">NovaSeq</label>
				</td>
				<td class="status" id="flowCellType.status"></td>
				<td class="help">
					<span id="flowCellType.message" class="message"></span>
					The type of flow cell. Only NovaSeq is supported so far.
				</td>
			</tr>
			<tr>
				<td class="prompt">Lanes/flow cell</td>
				<td class="input" id="lanes">
					<label><input type="radio" name="num_lanes" id="num_lanes_2" value="2" checked>2</label>
					<label><input type="radio" name="num_lanes" id="num_lanes_4" value="4">4</label>
				</td>
				<td class="status" id="lanes.status"></td>
				<td class="help">
					<span id="lanes.message" class="message"></span>
					Select the number of lanes on the flow cell.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Comments</td>
				<td class="input">
					<textarea name="comments" id="comments" rows="4"></textarea>
				</td>
				<td class="status" id="comments.status"></td>
				<td class="help">
					<span id="comments.message" class="message"></span>
					Comments about the sequencing.
				</td>
			</tr>
			<tbody id="auto-analyze-section">
				<tr class="section-header">
					<td colspan="4">Auto-analyze options</td>
				</tr>
				<tr>
					<td class="subprompt">Auto-analyze</td>
					<td class="input">
						<label><input type="radio" name="autoAnalyze" id="autoAnalyzeYes" disabled>Yes</label>
						<label><input type="radio" name="autoAnalyze" id="autoAnalyzeNo" disabled>No</label>
					</td>
					<td class="status" id="autoAnalyze.status"></td>
					<td class="help">
						<span id="autoAnalyze.message" class="message"></span>
						If the auto-analyze option is enabled, Reggie will automatically detect
						when the sequencing has ended. If everything seems to be okay, 
						secondary analysis is automatically started.
					</td>
				</tr>
				<tr>
					<td class="subprompt">Cluster</td>
					<td class="input">
						<select name="clusters" id="clusters" class="required" disabled></select>
					</td>
					<td class="status" id="clusters.status"></td>
					<td class="help">
						<span id="clusters.message" class="message"></span>
						Select the cluster to use for running the analysis.
					</td>
				</tr>
				<tr id="job-priority" style="display: none;">
					<td class="subprompt">Job priority</td>
					<td class="input">
						<select name="priority" id="priority" disabled></select>
					</td>
					<td class="status" id="priority.status"></td>
					<td class="help">
						<span id="priority.message" class="message"></span>
						Select the priority of the analysis jobs.
					</td>
				</tr>
				<tr id="job-partition" style="display: none;">
					<td class="subprompt">Job partition</td>
					<td class="input">
						<select name="partition" id="partition"></select>
					</td>
					<td class="status" id="partition.status"></td>
					<td class="help">
						<span id="partition.message" class="message"></span>
						Select the partition/queue that the job should be submitted to.
					</td>
				</tr>
				<tr>
					<td class="subprompt">Debug</td>
					<td class="input"><input type="checkbox" name="debug" disabled></td>
					<td class="status" id="debug.status"></td>
					<td class="help">
						<span id="debug.message" class="message"></span>
						When running in debug mode only part of the sequenced data is used and
						temporary files are not removed from the cluster nodes.
					</td>
				</tr>
			</tbody>
			</table>
		</div>
	</div>
	
	<table class="navigation" id="navigation" style="margin-bottom: 1em;">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>

	<div id="wizard-status"></div>
	
	
	<div id="debug-tools">
		<select name="libplate" id="libplate"></select>
		<base:button 
			id="btnFakeSampleSheet"
			image="bug.png"
			title="Fake sample sheet file" 
			tooltip="Generate a fake sample sheet file"
		/>
	</div>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>