var MRNAreg = function()
{
	var mrnareg = {};
	var debug = 0;

	var commentsIsValid = false;

	// Page initialization
	mrnareg.initPage = function()
	{
		// Step 1
		Events.addEventHandler('bioplate', 'change', mrnareg.bioPlateOnChange);
		Events.addEventHandler('step-1', 'wizard-validate', mrnareg.validateStep1);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', mrnareg.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', mrnareg.validateStep2);
		Events.addEventHandler('purificationDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('fragmentationDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('cleanupDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('comments', 'blur', mrnareg.commentsOnChange);
		Wizard.initFileSelectionField('pdf');
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', mrnareg.submit);
		
		var url = '../MRna.servlet?ID='+App.getSessionId();
		url += '&cmd=GetUnprocessedPlates&plateType=MRNA&onlyDiluted=1';		
		Wizard.showLoadingAnimation('Loading mRNA plates...');
		Wizard.asyncJsonRequest(url, mrnareg.initializeStep1);
	}


	mrnareg.initializeStep1 = function(response)
	{
		var frm = document.forms['reggie'];
		var bioplates = response.bioplates;
		
		var plates = frm.bioplate;
		if (bioplates.length > 0)
		{
			for (var i=0; i < bioplates.length; i++)
			{
				var bioplate = bioplates[i];
				var name = bioplate.name;
				if (bioplate.AutoProcessing == 'PreNormalizeRNA')
				{
					name += ' (pre-normalized)';
				}
				else if (bioplate.DilutionDate)
				{
					name += ' (diluted ' + Reggie.reformatDate(bioplate.DilutionDate) + ')';
				}
				
				var option = new Option(name, bioplate.id);
				option.plate = bioplate;
				plates.options[plates.length] = option;
			}
			bioplateIsValid = true;
			Wizard.setInputStatus('bioplate', 'valid');
			mrnareg.bioPlateOnChange();
		}
		else
		{
			Wizard.setFatalError('No mRNA bioplates available for processing.');
			return;
		}

		Doc.show('step-1');
		Doc.show('gonext');
		frm.bioplate.focus();

	}
	
	mrnareg.bioPlateOnChange = function()
	{
		var frm = document.forms['reggie'];
		var bioplate = frm.bioplate[frm.bioplate.selectedIndex].plate;
		Doc.element('comments-info').innerHTML = Strings.encodeTags(bioplate.comments);
	}

	mrnareg.validateStep1 = function()
	{}
	
	mrnareg.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];	
		frm.comments.value = frm.bioplate[frm.bioplate.selectedIndex].plate.comments;
		Doc.addOrRemoveClass('comments', 'required', Doc.element('outcomeFailed').checked);
		mrnareg.commentsOnChange();
	
		Wizard.setCurrentStep(2);
		if (Doc.element('outcomeFailed').checked)
		{
			Wizard.showGoNextConfirmation(true, 'Check to verify registration of failure.');
		}
		Doc.show('gocancel');
		Doc.show('goregister');
		
		Events.sendChangeEvent('pdf');
		
		Reggie.loadProtocols('MRNA_PROTOCOL', 'mrnaProtocol');
		frm.purificationDate.focus();
	}

	mrnareg.commentsOnChange = function()
	{
		var frm = document.forms['reggie'];
		commentsIsValid = false;
		Wizard.setInputStatus('comments');
		
		var comments = frm.comments.value;
		if (comments == '' && Doc.element('outcomeFailed').checked)
		{
			Wizard.setInputStatus('comments', 'invalid', 'Missing');
			return;
		}

		Wizard.setInputStatus('comments', 'valid');
		commentsIsValid = true;
	}

	mrnareg.validateStep2 = function(event)
	{
		var valid = true;
		
		valid &= Wizard.isValid('pdf');
		valid &= commentsIsValid;
		valid &= Wizard.isValid('purificationDate');
		valid &= Wizard.isValid('fragmentationDate');
		valid &= Wizard.isValid('cleanupDate');
		
		if (!valid) event.preventDefault();
	}
	
	mrnareg.submit = function()
	{
		var frm = document.forms['reggie'];

		var submitInfo = {};
		submitInfo.bioplate = parseInt(frm.bioplate.value, 10);
		submitInfo.mrnaProtocol = parseInt(frm.mrnaProtocol.value, 10);
		submitInfo.failed = Doc.element('outcomeSuccess').checked ? false : true;
		submitInfo.pdf = frm.pdf.value;
		submitInfo.purificationDate = frm.purificationDate.value;
		submitInfo.purificationOperator = frm.purificationOperator.value;
		submitInfo.fragmentationDate = frm.fragmentationDate.value;
		submitInfo.fragmentationOperator = frm.fragmentationOperator.value;
		submitInfo.cleanupDate = frm.cleanupDate.value;
		submitInfo.cleanupOperator = frm.cleanupOperator.value;
		submitInfo.comments = frm.comments.value;
		
		var url = '../MRna.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportMRnaQCResults';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, mrnareg.submissionResults, 'POST', JSON.stringify(submitInfo));
	}

	mrnareg.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	return mrnareg;
}();

Doc.onLoad(MRNAreg.initPage);

